# coding: utf-8

"""
    Metadata API

    The Metadata API has operations that retrieve configuration details pertaining to the different eBay marketplaces. In addition to marketplace information, the API also has operations that get information that helps sellers list items on eBay.  # noqa: E501

    OpenAPI spec version: v1.11.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SiteVisibilityPoliciesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'site_visibility_policies': 'list[SiteVisibilityPolicy]',
        'warnings': 'list[Error]'
    }

    attribute_map = {
        'site_visibility_policies': 'siteVisibilityPolicies',
        'warnings': 'warnings'
    }

    def __init__(self, site_visibility_policies=None, warnings=None):  # noqa: E501
        """SiteVisibilityPoliciesResponse - a model defined in Swagger"""  # noqa: E501
        self._site_visibility_policies = None
        self._warnings = None
        self.discriminator = None
        if site_visibility_policies is not None:
            self.site_visibility_policies = site_visibility_policies
        if warnings is not None:
            self.warnings = warnings

    @property
    def site_visibility_policies(self):
        """Gets the site_visibility_policies of this SiteVisibilityPoliciesResponse.  # noqa: E501

        This array contains applicable policy metadata for the leaf categories returned for the marketplace specified in the path parameter <b>marketplace_id</b> and optionally limited by only those leaf category IDs specified in the query parameter <b>filter</b>.  # noqa: E501

        :return: The site_visibility_policies of this SiteVisibilityPoliciesResponse.  # noqa: E501
        :rtype: list[SiteVisibilityPolicy]
        """
        return self._site_visibility_policies

    @site_visibility_policies.setter
    def site_visibility_policies(self, site_visibility_policies):
        """Sets the site_visibility_policies of this SiteVisibilityPoliciesResponse.

        This array contains applicable policy metadata for the leaf categories returned for the marketplace specified in the path parameter <b>marketplace_id</b> and optionally limited by only those leaf category IDs specified in the query parameter <b>filter</b>.  # noqa: E501

        :param site_visibility_policies: The site_visibility_policies of this SiteVisibilityPoliciesResponse.  # noqa: E501
        :type: list[SiteVisibilityPolicy]
        """

        self._site_visibility_policies = site_visibility_policies

    @property
    def warnings(self):
        """Gets the warnings of this SiteVisibilityPoliciesResponse.  # noqa: E501

        An array of the warnings that were generated as a result of the request. This field is not returned if no warnings were generated by the request.  # noqa: E501

        :return: The warnings of this SiteVisibilityPoliciesResponse.  # noqa: E501
        :rtype: list[Error]
        """
        return self._warnings

    @warnings.setter
    def warnings(self, warnings):
        """Sets the warnings of this SiteVisibilityPoliciesResponse.

        An array of the warnings that were generated as a result of the request. This field is not returned if no warnings were generated by the request.  # noqa: E501

        :param warnings: The warnings of this SiteVisibilityPoliciesResponse.  # noqa: E501
        :type: list[Error]
        """

        self._warnings = warnings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SiteVisibilityPoliciesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SiteVisibilityPoliciesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
